#
# Copyright (c) 1995 The Ohio State University.
# All rights reserved.
#
# Redistribution and use in source and binary forms are permitted
# provided that: (1) source distributions retain this entire copyright
# notice and comment, and (2) distributions including binaries display
# the following acknowledgement:  ``This product includes software
# developed by The Ohio State University and its contributors''
# in the documentation or other materials provided with the distribution
# and in all advertising materials mentioning features or use of this
# software. Neither the name of the University nor the names of its
# contributors may be used to endorse or promote products derived
# from this software without specific prior written permission.
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#

$options = "hd:";
$usage = 
"usage: 
    promise -h				for help
    promise [-d level] drive N		to promise N tapes
";

require 'global.defs';
require 'local.defs';

require $yagrip_perl;
require $backuplib_perl;
require $lib_db_extra_perl;

&read_config();			# Read backup.config file

#
# Make sure that we clean up after ourselves if someone wants to kill us.
#
$SIG{'INT'} = 'handle_interrupts';
$SIG{'HUP'} = 'handle_interrupts';
$SIG{'TERM'} = 'handle_interrupts';
$SIG{'QUIT'} = 'handle_interrupts';

#
# Deal with args
#
die $usage if ! &getopt($options);
die $usage if $#ARGV != 1;
die $usage if defined($opt_h);

if (defined($opt_d)) {
    $debug_string = "-d $opt_d";
} else {
    $debug_string = "";
}

$drive = shift;
$number = shift;

@tapes = &choose_tape($tape_type{$drive}, $tape_reads{$drive}, 
		      $tape_writes{$drive}, $tape_location{$drive}, 
		      $number, "*");

foreach $tape (sort @tapes) {
    print $tape, "\n";
}
