#
# Copyright (c) 1992 The Ohio State University.
# All rights reserved.
#
# Redistribution and use in source and binary forms are permitted
# provided that: (1) source distributions retain this entire copyright
# notice and comment, and (2) distributions including binaries display
# the following acknowledgement:  ``This product includes software
# developed by The Ohio State University and its contributors''
# in the documentation or other materials provided with the distribution
# and in all advertising materials mentioning features or use of this
# software. Neither the name of the University nor the names of its
# contributors may be used to endorse or promote products derived
# from this software without specific prior written permission.
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#

@Months = ("jan", "feb", "mar", "apr", "may", "jun", "jul", 
	   "aug", "sep", "oct", "nov", "dec");

$options = "";
$usage = 
"usage: run-clean-db\n";

require 'global.defs';
require 'local.defs';
require $backuplib_perl;

die $usage if $#ARGV != -1;

&read_config();

if (! defined($clean_db_log_dir)) {
  die "error (run-clean-db): update your global.defs file, clean_db_log_dir isn't defined!\n";
}

#
# Create the clean-db log directory and cd to it...
#
if (! -d $clean_db_log_dir) {
    mkdir($clean_db_log_dir, $db_mode) ||
      die "error (run-clean-db): cannot create $clean_db_log_dir, bailing out...\n";
}

chdir($clean_db_log_dir) ||
  die "error (run-clean-db): cannot CD to $clean_db_log_dir, bailing out...\n";

#
# Clean out old entries...
#
foreach $file (<*>) {
    if ((time - (stat($file))[10]) > $clean_db_timeout) {
	system("$rm_prog -f $file");
    }
}

#
# Create today's entry...
#
@local_time = localtime(time);
$log_file = sprintf("%s-%d", 
		    $Months[$local_time[4]], 
		    $local_time[3]);

if (-e $log_file) {
    $log_file .= sprintf("-%d:%d:%d",
			 $local_time[2],
			 $local_time[1],
			 $local_time[0]);
}

$command = "$clean_db_prog -v -y > $log_file 2>&1";
if (system($command)) {
    warn "warning (run-clean-db): command $command failed.\n";
}

$command = "$egrep_prog '^warning:|^info:' $log_file > /tmp/$$.tmp";
system($command);

if ($send_empty_mail || -s "/tmp/$$.tmp") {
    $command = "$mail_prog -s 'clean-db results' $mail_to < /tmp/$$.tmp";
    if (system($command)) {
	warn "warning (run-clean-db): command $command failed.\n";
    }
}
unlink "/tmp/$$.tmp";

exit(0);
