#
# Copyright (c) 1991,1992 The Ohio State University.
# All rights reserved.
#
# Redistribution and use in source and binary forms are permitted
# provided that: (1) source distributions retain this entire copyright
# notice and comment, and (2) distributions including binaries display
# the following acknowledgement:  ``This product includes software
# developed by The Ohio State University and its contributors''
# in the documentation or other materials provided with the distribution
# and in all advertising materials mentioning features or use of this
# software. Neither the name of the University nor the names of its
# contributors may be used to endorse or promote products derived
# from this software without specific prior written permission.
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#

#
# Nuke the dumpdates.lock on a host.
#
# Steve Romig, October 15, 1991.
#

require 'global.defs';
require 'local.defs';

$usage = "usage: unlock-dumpdates\n";

#
# Make sure that we clean up after ourselves if someone wants to kill us.
#
$SIG{'INT'} = 'handle_interrupts';
$SIG{'HUP'} = 'handle_interrupts';
$SIG{'TERM'} = 'handle_interrupts';
$SIG{'QUIT'} = 'handle_interrupts';

if ($#ARGV != -1) {
    die $usage;
}

$file = $dump_lock . ".lock";

if (-e $file) {
    if (unlink("$dump_lock.lock") != 1) {
	print "Dumpdates is now unlocked.\n";
    } else {
	print "warning (unlock-dumpdates): couldn't unlock dumpdates, sorry.\n";
    }
} else {
    print "warning (unlock-dumpdates): $file doesn't exist.\n";
}
